//-------------------------------------------------------------------------
/*
Copyright (C) 2000, 2003 - Justin Marshall(WinEDuke)

This file is part of Windows Enhanced Duke Nukem 3D version 1.5 - Atomic Edition

Duke Nukem 3D is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Original Source: 1996 - Todd Replogle
Prepared for public release: 03/21/2003 - Charlie Wiederhold, 3D Realms

NOTE: This file handles all console related pharsing, init, etc
*/
//-------------------------------------------------------------------------

#define MAX_LINES_IN_BUFFER 500000
#define MAX_LINE_SIZE 100

char *GetConsoleText(void);
void AddConsoleText(char *buf);
void Con_Print(char *buf);
void RegisterCvar(char *name,char *value,void *func);
void SetCvar(char *name,char *value);
void HandleCvar(char *buf,int size);

void cvarlist(void);

typedef struct
{
	char buffer[MAX_LINES_IN_BUFFER][MAX_LINE_SIZE];
	int numlinesused;
	int maxdrawline;
}console_buffer;

typedef struct
{
	char registeredcvars[400][100];
	char registeredcvarvalues[400][100];
	int curr_cvar;
}cvar_t;

cvar_t cvar;
cvar_t s_cvar; // used for saving console cvars
extern char *tempbuffer;
extern char *line;
extern char *tempbuffer2;
extern int linepos,lastpos,j;
extern int numlines;

extern console_buffer con_buffer;